/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package xpath;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import static javax.management.Query.value;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class XPathEvaluator {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            if(args.length!=2){
                System.err.println("Usage:\n\tjava -jar XPath.jar data XPath_expression");
                System.exit(-1);
            }
            XPathFactory xpf = XPathFactory.newInstance();
            XPath xPath = xpf.newXPath();
            DocumentBuilderFactory dbf=DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = dbf.newDocumentBuilder();
            Document doc= builder.parse(new File(args[0]));
            
            NodeList elements = (NodeList) xPath.evaluate(args[1], doc.getDocumentElement(),XPathConstants.NODESET);
            TransformerFactory tf=TransformerFactory.newInstance();
            Transformer trans = tf.newTransformer();
            Element root = doc.createElement("results");
            System.out.println(String.format("\nVyhodnoceni dotazu %s:", args[1]));
            for(int i=0;i<elements.getLength();i++){
                Node node = elements.item(i);
                if(node instanceof Element){
                    root.appendChild((Element)elements.item(i));
                }
                else{
                    Element el = doc.createElement("result");
                    root.appendChild(el);
                    Attr attr = (Attr) node;
                    el.setAttribute(attr.getName(),attr.getTextContent());
                }
            }
            trans.transform(new DOMSource(root),new StreamResult(System.out));
        } catch (XPathExpressionException ex) {
            Logger.getLogger(XPathEvaluator.class.getName()).log(Level.SEVERE, "Chyba pri vyhodnocovani xpath:", ex.getMessage());
        } catch (ParserConfigurationException | SAXException | IOException ex) {
            Logger.getLogger(XPathEvaluator.class.getName()).log(Level.SEVERE, "Chyba parseru:", ex);
        } catch (TransformerException ex) {
            Logger.getLogger(XPathEvaluator.class.getName()).log(Level.SEVERE, "Chyba transformace:", ex);
        }
        System.out.println("");
    }
    
}
